/* ens_tab.h
 * Fichier d'en tete pour l'implantation d'un ensemble d'entier de 0  N-1
 * Auteur : VOURIOT Thierry
 * Date : 14 novembre 2001
 */

#include "base.h"

/* Taille de l'ensemble */
#define N 50

/* Implantation sous la forme d'un tableau de booleens */
typedef struct sEns
{
	Bool v[N];
}Ens;

/* Creation d'un ensemble vide */
extern Ens ensnouv(void);

/* Insertion d'un entier 
 * pre ins(e,x) = 0<=x<=N-1 et !app(e,x)
 */
extern Ens ins(Ens, Nat);

/* Creation d'un ensemble avec un entier 
 * pre sing(x) = 0<=x<=N-1
 */
extern Ens sing(Nat);

/* Suppression d'un entier 
 * pre supp(e,x) = 0<=x<=N-1 et app(e,x)
 */
extern Ens supp(Ens, Nat);

/* Teste si un entier appartient a l'ensemble 
 * pre app(e,x) = 0<=x<=N-1
 */
extern Bool app(Ens, Nat);

/* Retourne l'union de 2 ensemble */
extern Ens unio(Ens, Ens);

/* Retourne l'intersection de 2 ensemble */
extern Ens inter(Ens, Ens);

/* Creation de l'ensemble "plein" */
extern Ens ref(void);

/* Cardinalite (nb d'elements) de l'ensemble */
extern Nat card(Ens);

/* Teste si un ensemble est vide */
extern Bool vide(Ens);

/* Teste si le second enemble est inclus dans le premier */
extern Bool inclu(Ens, Ens);

/* Teste l'egalite de 2 ensembles */
extern Bool eg(Ens, Ens);

/* Retourne le complementaire d'un ensemble */
extern Ens comp(Ens);

/* Retourne la difference de 2 ensembles */
extern Ens diff(Ens, Ens);

/* Copie d'un ensemble */
extern Ens copie(Ens);

/* Affiche sur la sortie standard les valeurs de l'ensemble */
extern void aff(Ens e);

/* Lit un ensemble au clavier */
extern Ens lirens(void);





