/* liste_ch.h
 * Fichier en tete pour l'implantation des listes chainees d'entiers
 * Auteur : VOURIOT Thierry
 * Date : 5 janvier 2002
 */

#include "base.h"

/* Definition de la structure des listes chainees */
typedef struct sListe
{
	Nat v;
	struct sListe *s;
} SListe, *Liste;

/* Creation d'une nouvelle liste */
extern Liste listenouv(void);

/* Adjonction en tete */
extern Liste adjt(Liste, Nat);

/* Adjonction en queue */
extern Liste adjq(Liste, Nat);

/* Suppression en tete 
 * pre suppt(l) = non vide(l)
 */
extern Liste suppt(Liste);

/* Tete 
 * pre tete(l) = non vide(l)
 */
extern Nat tete(Liste);

/* Queue 
 * pre queue(l) = non vide(l)
 */
extern Nat queue(Liste);

/* Teste si la liste est vide */
extern Bool lvide(Liste);

/* Longueur (nbre d'elements) */
extern Nat lgr(Liste);

/* Decalage circulaire vers la gauche */
extern Liste decg(Liste);

/* Affiche la liste a l'ecran */
extern void laff(Liste);

/* Element a l'indice donne 
 * pre elem(l,i) = 0 <= i < lgr(l)
 */
extern Nat elem(Liste, Nat);

