# liste_hamilton.spec
# Specification algebrique des listes pour
# le projet sur les chemins hamiltoniens
# Auteur : VOURIOT Thierry
# Date : 27 novembre 2001

# Sorte S definissant l'egalite
spec EG etend BASE

	sorte S

	operations

		==: S S -> Bool		#Egalite
		!=: S S -> Bool		#Difference

	axiomes

		(x==x) = vrai
		(x!=y) = non (x==y)

fspec

spec LISTE(EG) etend BASE

	sorte Liste

	operations

		listenouv: -> Liste	#Creation d'une liste vide
		adjt: Liste S -> Liste	#Adjonction en tete
		suppt: Liste -> Liste	#Suppression en tete
		tete: Liste -> S	#Tete
		lvide: Liste -> Bool	#Teste si la liste est vide
		lgr: Liste -> Nat	#Longueur (nbre d'elements)
		adjq: Liste S -> Liste	#Adjonction en queue
		queue: Liste -> S	#Queue
		decg: Liste -> Liste	#Decalage  gauche
		laff: Liste ->		#Affichage
		elem: Liste Nat -> S	#Element a un indice donne


	preconditions 

		pre suppt(l) = non vide(l)
		pre tete(l) = non vide(l)
		pre queue(l) = non vide(l)
		pre elem(l,i) = 0 <= i < lgr(l)
		

	axiomes 
		#Constructeurs listenouv et adjt

		suppt(adjt(l,x)) = l

		tete(adjt(l,x)) = x

		lvide(listenouv) = vrai
		lvide(adjt(l,x)) = faux

		lgr(listenouv) = 0
		lgr(adjt(l,x)) = lgr(l) + 1

		adjq(listenouv,x) = adjt(listenouv,x)
		adjq(adjt(l,x),y) = adjt(adjq(l,y),x)

		queue(adjq(l,x)) = x

		decg(listenouv) = listenouv
		decg(adjt(l,x)) = adjq(l,x)

		laff(l) = 
			avec (l1,i) = init(l,lgr(l))
			tantque i > 0
			rep ecrire tete(l)
			 (decg(l), i-1) frep

		elem(l,i) = tete(l1)
			avec (l1,k) = init(l,0)
			tantque k < i
			rep (decg(l1),k+1) frep

fspec

