/* uhamilton.c
 * Programme de tests pour le projet sur les chemins hamiltoniens
 * Auteur : VOURIOT Thierry
 * Date : 14 janvier 2002
 */

#include "graphe_ma.h"

void aff_menu(void);

/* Vide le tampon associe a stdin */
void vide_stdin()
{
	char c = getchar();
	if (c != '\n')
		while ( (getchar()) !=  '\n');
}

int main() 
{
	char c;	
	Graphe g;

    	for (aff_menu();(c=getchar())!='q';aff_menu()) 
	{

        	vide_stdin();
        	switch(c) {
        		case 'a': { 
				g = grnouv();
				g = adjs(adjs(adjs(adjs(g,1),2),3),4);
				g = adja(adja(adja(g,2,1),1,3),1,4);
				g = adja(adja(adja(g,3,2),2,4),4,3);
				printf("\nmatrice d'adjacences :\n");
				affMat(g);
				printf("\ngraphe complet = %s\n",complet(g)?"vrai":"faux");
				printf("degre du centre %d = %d\n",centre(g,es(g)),de(g,centre(g,es(g))));
				printf("liste des sommets = ");laff(ls(g));
				printf("chemin hamiltonien = ");laff(hamilton(g));
				break; 
			}
			case 'b': { 
				g = grnouv();
				g = adjs(adjs(adjs(adjs(adjs(adjs(g,2),4),6),8),10),12);
				g = adja(adja(adja(adja(adja(g,2,4),4,6),6,8),8,10),10,12);
				g = adja(adja(adja(adja(g,12,2),2,6),8,2),10,2);
				g = adja(adja(adja(adja(adja(g,4,12),4,10),8,4),12,6),10,6);
				g = adja(g,12,8);
				printf("\nmatrice d'adjacences :\n");
				affMat(g);
				printf("\ngraphe complet = %s\n",complet(g)?"vrai":"faux");
				printf("degre du centre %d = %d\n",centre(g,es(g)),de(g,centre(g,es(g))));
				printf("liste des sommets = ");laff(ls(g));
				printf("chemin hamiltonien = ");laff(hamilton(g));
				break; 
			}
    		}
	}
}

void aff_menu() {

     	printf("\n\n TESTS DES CHEMINS HAMILTONIENS ( ds les graphes complets)\n");
     	printf("\na. Exemple A : 4 sommets");
	printf("\nb. Exemple B : 6 sommets");
     	printf("\nq. Quitter");
     	printf("\n\nChoix :");
}
